// main.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "cudaCode.h"
#include "mainProgram.h"
#include "fstream"
#include "iostream"

using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
	int N = 10;

	// Create pointers to arrays.
	objects *obj_h;
	save *results_h;

	// Number of bytes that each array will need.
	size_t obj_size = N * sizeof(objects);
	size_t results_size = N * sizeof(save);

	// Allocate memory on CPU.
	obj_h =(objects *)malloc(obj_size);
	results_h = (save *)malloc(results_size);

	// Load data from file to obj_h.
	loadDataFromFile(obj_h, N);

	// Print data to make sure that the load function worked.
//	printData(obj_h, N);

	computeCPA(obj_h, results_h, N);

	return 0;
}

void loadDataFromFile(objects* obj_h, int N){

	ifstream readFile("10_objectsCPA.txt");

	if(readFile.is_open()){
		for(int i=0; i<N; i++){
			readFile >> obj_h[i].id;
			readFile >> obj_h[i].positionX;
			readFile >> obj_h[i].positionY;
			readFile >> obj_h[i].speedX;
			readFile >> obj_h[i].speedY;
		} // End for.
	} // End if.
	
	else{
		cout << "The file could not be read.\n";
	}
}

void printResultsToFile(save* results, int N){
	ofstream out;
	out.open("output.txt");

	for(int i=0; i<N; i++){
		out << results[i].id << "\n";
		out << results[i].time << "\n";
		out << results[i].closestNeighbour << "\n\n";
	}
	out.close();
}

void printData(objects* obj_h, int N){
	for(int i=0; i<N; i++){
		cout << "ID: " << obj_h[i].id << "\n" 
		<< "Pos X: " << obj_h[i].positionX << "\n" 
		<< "Pos Y: " << obj_h[i].positionY << "\n" 
		<< "Speed X: " << obj_h[i].speedX << "\n" 
		<< "Speed Y: " << obj_h[i].speedY << "\n";
	}
}